/********************************************************
 ***** This program is written by Zuskin 03.06.2011 *****
 ** You can do anything you like with it, i don't care **
 ********************************************************/
using namespace std;
#include <string>
#include <stdio.h>
#include <termios.h>
#include <fcntl.h>

int PortFileDescr = 0;

void set_timeout( int tsec){
    struct termios options;
    tcgetattr(PortFileDescr, &options);
    options.c_cc[VTIME] = tsec;//msec
    tcsetattr(PortFileDescr, TCSANOW, &options);
  };

int open_port(string str){
    int fd;
    struct termios options;
    fd = open(str.c_str(), O_RDWR | O_NOCTTY | O_NDELAY);
    if (fd != -1)
    {
       fcntl(fd, F_SETFL, 0);
       tcgetattr(fd, &options);
       options.c_cflag |= (CLOCAL | CREAD);
       options.c_cflag &= ~PARENB;
       options.c_cflag &= ~CSTOPB;
       options.c_cflag &= ~CSIZE;
       options.c_cflag |= CS8;
       options.c_lflag &= ~(ICANON | ECHO | ECHOE | ISIG);
       options.c_oflag &= ~OPOST;
       options.c_iflag &= ~(IXON | IXOFF | IXANY);
       options.c_iflag &= ~IGNCR;
       options.c_iflag &= ~ICRNL;
       options.c_cc[VMIN] = 0;
       options.c_cc[VTIME] = 5;
       tcsetattr(fd, TCSANOW, &options);
       PortFileDescr = fd;
       return 0;
    }
    return -1;
};


void set_port_speed(int BaudRate){
    
    struct termios options;
    tcgetattr(PortFileDescr, &options);
    printf("на скорости ");
    switch (BaudRate)
    {
      case 1: {cfsetispeed(&options, B1200);cfsetospeed(&options, B1200);printf("1200\n");break;}
      case 2: {cfsetispeed(&options, B2400);cfsetospeed(&options, B2400);printf("2400\n");break;}
      case 3: {cfsetispeed(&options, B4800);cfsetospeed(&options, B4800);printf("4800\n");break;}
      case 4: {cfsetispeed(&options, B9600);cfsetospeed(&options, B9600);printf("9600\n");break;}
      case 5: {cfsetispeed(&options, B19200);cfsetospeed(&options, B19200);printf("19200\n");break;}
      case 6: {cfsetispeed(&options, B38400);cfsetospeed(&options, B38400);printf("38400\n");break;}
      case 7: {cfsetispeed(&options, B57600);cfsetospeed(&options, B57600);printf("57600\n");break;}
      case 8: {cfsetispeed(&options, B115200);cfsetospeed(&options, B115200);printf("115200\n");break;}
      default: {cfsetispeed(&options, B4800);cfsetospeed(&options, B4800);printf("4800\n");}
    }
    tcsetattr(PortFileDescr, TCSADRAIN, &options);
};

int main(int argc, char* argv[]) { 
    if (argc < 3) {
	printf("недостаточно аргуменов\nзапуск: dncpl [имя файла порта] [скорость]\nпример: dncpl /dev/ttyUSB0 115200\n");
	return 0;
    }
    
    string devname (argv[1]);
    string baudrate (argv[2]);

    printf("открываем порт %s\n", argv[1]);
    if (open_port(devname) == -1) {
	printf("не удалось открыть указанный файл порта...\n");
	return 0;
    }
        
    int br = 0;
    if (baudrate == string("1200")) {br = 1;}
    else if (baudrate == string("2400")) {br = 2;}
    else if (baudrate == string("4800")) {br = 3;}
    else if (baudrate == string("9600")) {br = 4;}
    else if (baudrate == string("19200")) {br = 5;}
    else if (baudrate == string("38400")) {br = 6;}
    else if (baudrate == string("57600")) {br = 7;}
    else if (baudrate == string("115200")) {br = 8;}
    
    set_port_speed(br);	
    set_timeout(1);
    
    printf("нажмите [Cntrl]+[C] для завершения...\n");    
    int n = 0;
    bool flg = false;
    while (1==1) {
        unsigned char ch[1];
	unsigned char * ch1 = ch;
        n = read(PortFileDescr, ch1, 1);
	if (n > 0) {
		printf("|%X|", ch1[0]);
		flg = true;
	}
	else {
	    if (flg == true) { printf("\n"); flg = false; }
	}
    }
    return 0;
}
